#include "mint.h"
int sim_read (task_ptr ptask);
int read_from_memory (task_ptr ptask);
int complete_read (task_ptr ptask);

int sim_write (task_ptr ptask);
int write_to_memory (task_ptr ptask);
int complete_write (task_ptr ptask);

int
sim_read (task_ptr ptask)
{
  task_ptr ntask;

#ifdef  TRACE
  printf ("sim_read (back-end): ptask = 0x%x %f\n",
	  ptask, ptask->time);
#endif /* TRACE */
  sched_task (ptask, read_from_memory, ptask->time + 10);
  return T_FREE;
}

int
read_from_memory (task_ptr ptask)
{
  event_ptr pevent;
  task_ptr ntask;

#ifdef  TRACE
  printf ("read_from_memory (back-end): ptask = 0x%x %f\n",
          ptask, ptask->time);
#endif	/* TRACE */

  pevent = ptask->pevent;

#ifdef MOVE_DATA
  mem_ref (pevent); 
#endif /* MOVE_DATA */

  sched_task (ptask, complete_read, ptask->time + 30);
  return T_FREE;
}

int
complete_read (task_ptr ptask)
{
#ifdef  TRACE
  printf("complete_read (back-end): ptask = 0x%x %f\n",
         ptask, ptask->time);
#endif		/* TRACE */
  return T_ADVANCE;
}

int
sim_write (task_ptr ptask)
{
  task_ptr ntask;
#ifdef  TRACE
  printf ("sim_write (back-end): ptask = 0x%x %f\n",
          ptask, ptask->time);
#endif	/* TRACE */
  sched_task(ptask, write_to_memory, ptask->time+5);
  return T_FREE;
}

int
write_to_memory (task_ptr ptask)
{
  event_ptr pevent;
  task_ptr ntask;

#ifdef  TRACE
  printf ("write_to_memory (back-end): ptask = 0x%x %f\n",
          ptask, ptask->time);
#endif	/* TRACE */

  pevent = ptask->pevent;

#ifdef MOVE_DATA
  mem_ref (pevent); 
#endif /* MOVE_DATA */
  
  sched_task (ptask, complete_write, ptask->time + 12);
  return T_FREE;
}

int
complete_write (task_ptr ptask)
{
#ifdef  TRACE
  printf("complete_write (back-end): ptask = 0x%x %f\n",
         ptask, ptask->time);
#endif		/* TRACE */
  return T_ADVANCE;
}
