/*
 * basic.c,v 1.1.1.1 1996/03/03 17:39:50 arsharma Exp
 * Purpose: To recognize basic blocks in the asm code
 */

#include <stdio.h>
#include "doctor_t.h"
#include "doctab.h"
#include "mnemdef.h"
#include "basic.h"

bool_t
isjumper (int mnemonic)
{
    switch (mnemonic) {
	    /* Jumps */
	case JE:
	case JG:
	case JNLE:
	case JLE:
	case JNG:
	case JL:
	case JNGE:
	case JGE:
	case JNL:
	case JNE:
	case JA:
	case JNBE:
	case JBE:
	case JNA:
	case JB:
	case JC:
	case JNAE:
	case JAE:
	case JNB:
	case JNC:
	case JZ:
	case JNZ:
	case JS:
	case JNS:
	case JO:
	case JNO:
	case JP:
	case JPE:
	case JNP:
	case JPO:
	    /* unconditional jumps */
	case JMP:
	case LOOP:
	case LOOPE:
	case LOOPNE:
	case LOOPNZ:
	case LOOPZ:
	case JCXZ:
	case JECXZ:
	    /* calls and returns */
	case CALL:
	case INT:
	case INTO:
	case INT3:
	case RET:
	case IRET:
	    return 1;
	default:
	    return 0;
    }
}
