#ifndef _MEMREF_H
#define _MEMREF_H

/* memref.h,v 1.1.1.1 1996/03/03 17:39:51 arsharma Exp */

/* Macro for checking if an operand refers to memory */
#define MEM_REF(instr) (((instr)->mem_ref[0]) \
			|| ((instr)->mem_ref[1]))

/*
 * is_explicit_mem_ref looks at	      the instruction and returns one of
 * these values, indicating the type of the memory reference.
 */
enum enum_ref_t {
    NONE, FIRST, SECOND, IMPLICIT
};

/* Information about a	memory reference */
struct reference_type {
    unsigned read:1;		/* Indicates if this is a read */
    unsigned write:1;		/* Indicates if this is a write */
    unsigned implicit:1;	/* Implicit or explicit ? */
    unsigned stack:1;		/* To the stack ? */
    int stack_offset;		/* address = %esp+stack_offset */
    char *source;
    char *destination;
    char *format_string;	/* for stack references */
};

typedef struct reference_type ref_t;

/* forward definition of instr_t */
struct instruction_type;

void check_mem_ref (struct instruction_type *instr);
enum enum_ref_t is_explicit_mem_ref (struct instruction_type *instr);
char *get_first_op (struct instruction_type *instr);
char *get_second_op (struct instruction_type *instr);
void get_implicit_op (struct instruction_type *instr, ref_t *ref);
void handle_special_instr (struct instruction_type *instr);
bool_t jmp_memref (char *s);
char *convert_jmp_normal (char *operand);
char *skip_whitespaces (char *s);

#endif /* _MEMREF_H */
