#ifndef __MALLOC_H
#define __MALLOC_H
#include "hash.h"
/*
 * These entries hold information about allocated blocks. These entries
 * are stored in a hash table indexed by the address.
 */
typedef struct a_entry {
    unsigned long address;
    struct a_entry *next;
    unsigned int size;
    int bucket;
} a_entry_t, *a_entry_ptr;

#define A_ENTRY_SIZE (sizeof(struct a_entry))

/*
 * These entries hold information about free blocks. Each entry is stored
 * in a linked list. There is a separate linked list for each different
 * size block. The sizes are powers of two.
 */
typedef struct avail {
    struct avail *next;
    struct avail *prev;
    unsigned long address;
    int size;
} avail_t, *avail_ptr;

/* for malloc free lists */
static avail_ptr malloc_avail;
/* for malloc allocated blocks in hash table */
static hash_tab_ptr malloc_alloc;

#define ulong unsigned long

void malloc_init (ulong base, ulong size);
#endif /* __MALLOC_H */
