/*
 * Supports all the read and write events. Useful for protocol verification.
 *
 * Copyright (C) 1993 by Jack E. Veenstra (veenstra@cs.rochester.edu)
 * 
 * This file is part of MINT, a MIPS code interpreter and event generator
 * for parallel programs.
 * 
 * MINT is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 1, or (at your option)
 * any later version.
 * 
 * MINT is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with MINT; see the file COPYING.  If not, write to
 * the Free Software Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.
 */

#include <stdio.h>
#include "export.h"
#include "event.h"

void
mem_ref (event_ptr pevent)
{
    int i;
    char *src, *dest;

    if (pevent->type & E_READ) {
	src = (char *) pevent->paddr;
	dest = (char *) &pevent->value;
    }
    else if (pevent->type & E_WRITE) {
	src = (char *) &pevent->value;
	dest = (char *) pevent->paddr;
    }
    else {
	fatal ("mem_ref: wrong event type 0x%x\n", pevent->type);
    }

    for (i = 0; i < pevent->size; i++)
	*(char *) (dest + i) = *(char *) (src + i);
}
