char N_ones[] =
{
  0, 1, 1, 2, 1, 2, 2, 3, 1, 2, 2, 3, 2, 3, 3, 4, 1, 2, 2, 3, 2, 3, 3, 4, 2,
  3, 3, 4, 3, 4, 4, 5, 1, 2, 2, 3, 2, 3, 3, 4, 2, 3, 3, 4, 3, 4, 4, 5, 2, 3,
  3, 4, 3, 4, 4, 5, 3, 4, 4, 5, 4, 5, 5, 6, 1, 2, 2, 3, 2, 3, 3, 4, 2, 3, 3,
  4, 3, 4, 4, 5, 2, 3, 3, 4, 3, 4, 4, 5, 3, 4, 4, 5, 4, 5, 5, 6, 2, 3, 3, 4,
  3, 4, 4, 5, 3, 4, 4, 5, 4, 5, 5, 6, 3, 4, 4, 5, 4, 5, 5, 6, 4, 5, 5, 6, 5,
  6, 6, 7, 1, 2, 2, 3, 2, 3, 3, 4, 2, 3, 3, 4, 3, 4, 4, 5, 2, 3, 3, 4, 3, 4,
  4, 5, 3, 4, 4, 5, 4, 5, 5, 6, 2, 3, 3, 4, 3, 4, 4, 5, 3, 4, 4, 5, 4, 5, 5,
  6, 3, 4, 4, 5, 4, 5, 5, 6, 4, 5, 5, 6, 5, 6, 6, 7, 2, 3, 3, 4, 3, 4, 4, 5,
  3, 4, 4, 5, 4, 5, 5, 6, 3, 4, 4, 5, 4, 5, 5, 6, 4, 5, 5, 6, 5, 6, 6, 7, 3,
  4, 4, 5, 4, 5, 5, 6, 4, 5, 5, 6, 5, 6, 6, 7, 4, 5, 5, 6, 5, 6, 6, 7, 5, 6,
    6, 7, 6, 7, 7, 8,
};

/*
 * count_1bits() returns the number of bits set to 1.
 */

int
count_1bits (unsigned int bitvec)
{
    int n;

    n = N_ones[bitvec & 0xff];

    bitvec >>= 8;
    n += N_ones[bitvec & 0xff];

    bitvec >>= 8;
    n += N_ones[bitvec & 0xff];

    bitvec >>= 8;
    n += N_ones[bitvec];

    return n;
}

/*
 * bitpos() takes a bitvector which should contain a single 1-bit, and 
 * returns the bit position of that 1-bit. If no bits are set to 1,
 * then -1 is returned. If more than one bit is set to 1, then -2 is returned.
 *
 * Examples:
 *    bitpos(0x01)    returns 0
 *    bitpos(0x02)    returns 1
 *    bitpos(0x04)    returns 2
 *    bitpos(0x00)    returns -1
 *    bitpos(0x0f)    returns -2
 */

int
bitpos (unsigned int bitv)
{
    int i;

    if (bitv == 0)
	return -1;
    for (i = 0; bitv; i++, bitv >>= 1)
	if (bitv & 1)
	    break;
    if (bitv >> 1)
	return -2;
    return i;
}

/*
 * least1() returns the bit position of the least significant one bit.
 * If no bits are set to 1, then -1 is returned.
 */
int
least1 (unsigned int bitv)
{
    int i;

    if (bitv == 0)
	return -1;

    for (i = 0; bitv; i++, bitv >>= 1)
	if (bitv & 1)
	    break;
    return i;
}

/*
 * most1() returns the bit position of the most significant one bit.
 * If no bits are set to 1, then -1 is returned.
 *
 * This routine assumes there are 32 bits in an unsigned int.
 */
int
most1 (unsigned int bitv)
{
    int i;

    if (bitv == 0)
	return -1;

    for (i = 31; i != 0; i--)
	if (bitv & (1 << i))
	    break;
    return i;
}
